package com.airfrance.squalecommon.enterpriselayer.businessobject.rule;

/**
 * Visiteur des rgles qualit
 * Ce design pattern permet d'externaliser des traitements
 * sur les facteurs, critres et pratiques
 */
public interface QualityRuleBOVisitor {
    /**
     * 
     * @param pFactorRule facteur
     * @param pArgument argument
     * @return objet
     */
    public Object visit(FactorRuleBO pFactorRule, Object pArgument);

    /**
     * 
     * @param pCriteriumRule critre
     * @param pArgument argument
     * @return objet
     */
    public Object visit(CriteriumRuleBO pCriteriumRule, Object pArgument);

    /**
     * 
     * @param pPracticeRule pratique
     * @param pArgument argument
     * @return objet
     */
    public Object visit(PracticeRuleBO pPracticeRule, Object pArgument);
}
