package com.airfrance.squaleweb.applicationlayer.action.results;

import java.util.ArrayList;
import java.util.Iterator;

import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;

import org.apache.struts.action.ActionForm;
import org.apache.struts.action.ActionForward;
import org.apache.struts.action.ActionMapping;
import org.apache.struts.action.ActionMessage;
import org.apache.struts.action.ActionMessages;

import com.airfrance.jraf.helper.AccessDelegateHelper;
import com.airfrance.jraf.spi.accessdelegate.IApplicationComponent;
import com.airfrance.squalecommon.datatransfertobject.result.SqualeReferenceDTO;
import com.airfrance.squaleweb.applicationlayer.action.accessRights.AdminAction;
import com.airfrance.squaleweb.applicationlayer.formbean.reference.ReferenceForm;
import com.airfrance.squaleweb.applicationlayer.formbean.reference.ReferenceGridForm;
import com.airfrance.squaleweb.applicationlayer.formbean.reference.ReferenceListForm;
import com.airfrance.squaleweb.applicationlayer.formbean.reference.SetOfReferencesListForm;
import com.airfrance.squaleweb.transformer.ReferenceTransformer;
import com.airfrance.welcom.struts.transformer.WTransformerFactory;

/**
 * Actions sur le rfrentiel
 * Les actions sur le rfrentiel permettent de consulter les facteurs et les mtriques
 * de certaines applications mises en rfrence
 */
public class ReferenceAction extends AdminAction {

    /**
      * Ajout ou retrait de projets du rfrentiel
      * Les projets slectionns sont ajouts ou retirs du rfrentiel, puis les donnes affiches
      * sont mise  jour
      * @param pMapping le mapping.
      * @param pForm le formulaire  lire.
      * @param pRequest la requte HTTP.
      * @param pResponse la rponse de la servlet.
      * @return l'action  raliser.
      */
    public ActionForward updateReferentiel(ActionMapping pMapping, ActionForm pForm, HttpServletRequest pRequest, HttpServletResponse pResponse) {
        // Initialisation
        ActionMessages errors = new ActionMessages();
        ActionForward forward = null;
        ArrayList listOfReferences = new ArrayList();

        try {
            // On construit la liste des applications  ajouter/supprimer
            SetOfReferencesListForm referenceListForm = (SetOfReferencesListForm) pForm;
            // Parcours des references grille par grille
            for(int i=0; i<referenceListForm.getList().size(); i++) {
                Iterator refsIt = ((ReferenceListForm)((ReferenceGridForm) referenceListForm.getList().get(i)).getReferenceListForm()).getList().iterator();
                // Parcours de chaque reference dans une grille
                while (refsIt.hasNext()) {
                    ReferenceForm refForm = (ReferenceForm) refsIt.next();
                    // Ajout des rfrences slectionnes
                    if (refForm.isSelected()) {
                        SqualeReferenceDTO refDTO = (SqualeReferenceDTO) WTransformerFactory.formToObj(ReferenceTransformer.class, refForm)[0];
                        listOfReferences.add(refDTO);
                    }
                }
            }
            Object[] args = { listOfReferences };
            IApplicationComponent ac = AccessDelegateHelper.getInstance("Validation");
            Integer result = (Integer) ac.execute("updateReferentiel", args);
            // On construit le message de confirmation
            ActionMessage message = new ActionMessage("reference.updated", "", "");
            errors.add(ActionMessages.GLOBAL_MESSAGE, message);
            // Mise  jour des donnes affiches
            // le forward renvoie vers l'action qui liste
            forward = pMapping.findForward("success");

            // Sauvegarde des messages pour la confirmation dans la rponse
            saveMessages(pRequest, errors);
        } catch (Exception e) {
            // Traitement factoris des exceptions et transfert vers la page d'erreur
            handleException(e, errors, pRequest);
            saveMessages(pRequest, errors);
            forward = pMapping.findForward("total_failure");
        }
        return (forward);
    }

}
