package com.airfrance.squaleweb.applicationlayer.formbean.config;

import com.airfrance.squalecommon.datatransfertobject.config.SourceManagementDTO;
import com.airfrance.squaleweb.applicationlayer.formbean.RootForm;

/**
 * Contient les donnes des rcuprateurs de sources 
 */
public class SourceManagementForm extends RootForm {

    /** Id du rcuprateur de sources en String pour le rcuprer dans l'option */
    private String mId;

    /** Nom du rcuprateur de source */
    private String mName;

    /**
     * Constructeur par dfaut
     */
    public SourceManagementForm() {
        super();
    }

    /**
     * Constructeur
     * @param pSourceManagement le DTO
     */
    public SourceManagementForm(SourceManagementDTO pSourceManagement) {
        mId = Long.toString(pSourceManagement.getId());
        mName = pSourceManagement.getName();
    }

    /**
     * Mthode d'accs  mId
     * @return l'identifiant du rcuprateur de source
     */
    public String getId() {
        return mId;
    }

    /**
    * Mthode d'accs  mName
    * @return le nom du rcuprateur de source
    */
    public String getName() {
        return mName;
    }

    /**
    * Change la valeur de mId
    * @param pId le nouvel identifiant
    */
    public void setId(String pId) {
        mId = pId;
    }

    /**
     * Change la valeur de mId
     * @param pId le nouvel identifiant
     */
    public void setId(long pId) {
        mId = Long.toString(pId);
    }

    /**
      * Change la valeur de mName
      * @param pName le nouveau nom
      */
    public void setName(String pName) {
        mName = pName;
    }

}
