package com.airfrance.squalix.core;

import java.util.HashMap;

/**
 * Cette classe sert  l'change entre les diffrents tches
 * des paramtres qui ne doivent pas tre persists
 */
public class TaskData {

    /**
     * La map contenant les paramtres qui ne doivent pas etre persists
     */
    private HashMap mMap;

    /**
     * Constructeur
     */
    public TaskData() {
        super();
        mMap = new HashMap();
    }

    /**
     * 
     * @param pKey la cl du paramtre
     * @return l'objet associ  cette cl
     */
    public Object getData(String pKey) {
        return mMap.get(pKey);
    }

    /**
     * Insert dans la map le paramtre
     * @param pKey la cl dfinissant le paramtre
     * @param pData la valeur de la cl
     */
    public void putData(String pKey, Object pData) {
        mMap.put(pKey, pData);
    }

    //Liste des constantes qui servent de cl 

    /**
     * Chemin d'accs absolu  la vue
     * Cette variable est renseigne par le SourceManagement, elle est utilise
     * par les diffrentes tches qui ncessitent l'accs  des donnes
     * contenues dans un rpertoire. Ces tches font alors la concatnation de
     * ce chemin avec le nom de leur rpertoire.
     * Par exemple, la tche de compilation va chercher ses sources dans /vobs/squale/src/squaleCommon,
     * l'accs  ces sources se fera par concatnation du chemin dfini par le sourceManagement.
     * Ce chemin d'accs est dpendant du type de sourcemanagement
     *  (clearcase, filesystem, zip ...)
     * Pour clearcase : donne le chemin d'accs  la vue statique
     * qui a t monte par exemple :
     * /app/SQUALE/dev/data/cc_snapshot/squale_v2_0_act_quicktest_testcommon_squaledev/
     * La tche de compilation java ira donc chercher ses donnes dans le rpertoire
     * /app/SQUALE/dev/data/cc_snapshot/squale_v2_0_act_quicktest_testcommon_squaledev//vobs/squale/src/squaleCommon
     * (Noter le double slash qui est supeflu sur Unix)
     */
    public static final String VIEW_PATH = "view_path";
    
    /**
     * Classpath java de compilation
     * Il s'agit du classpath utilis par la tche de compilation java,
     * par exemple lib1.jar:lib2.jar
     */
    public static final String CLASSPATH = "classpath";
    
    /**
     * Les rpertoires contenant les fichiers compils
     */
    public static final String CLASSES_DIRS = "classes_dirs";
    
    /** 
     * Le rpertoire contenant les pages JSP compiles 
     */
    public final static String JSP_TO_JAVA_DIR = "jspToJava_dir";
    
    /** 
     * Le rpertoire contenant les classes Java des pages JSP compiles 
     */
    public final static String JSP_CLASSES_DIR = "jsp_classes_dir";
    
    
}
