package com.airfrance.squalix.tools.compiling;

import com.airfrance.squalecommon.util.messages.BaseMessages;

/**
 * Classe grant le RessourceBundle pour la tche de compilation.
 * @author m400832 (by rose)
 * @version 1.0
 */
public class CompilingMessages extends BaseMessages {
    /** Instance */
    static private CompilingMessages mInstance = new CompilingMessages();

    

    /**
     * Retourne la chane de caractre identifie par la cl.
     * @param pKey nom de la cl.
     * @return la chane associe.
     * 
     */
    public static String getString(String pKey) {
        return mInstance.getBundleString(pKey);
    }
    /**
     * 
     * Retourne la chane de caractre identifie par la cl.
     * @param pKey nom de la cl.
     * @param pValues les valeurs  insrer dans la chaine
     * @return la chane associe.
     */
    public static String getString(String pKey, Object[] pValues) {
        return mInstance.getBundleString(pKey, pValues);
    }

    /**
     * @param pKey clef
     * @param pArgument argument
     * @return chane associe
     */
    public static String getString(String pKey, Object pArgument) {
        return getString(pKey, new Object[] { pArgument });
    }

    /**
     * Constructeur par dfaut. Priv pour viter l'instanciation directe.
     */
    private CompilingMessages() {
        super("com.airfrance.squalix.tools.compiling.compiling");
    }
}
