package com.airfrance.squalix.util.parser;

import com.airfrance.squalecommon.enterpriselayer.businessobject.component.ClassBO;
import com.airfrance.squalecommon.enterpriselayer.businessobject.component.MethodBO;

/**
 * Parse les noms entiremement qualifi et les remplace par les objets
 * correspondants.
 */
public interface LanguageParser {

    /*################ Dcomposition et transformation en objet correspondant ################*/

    /**
     * Dcompose la mthode pour construire l'objet MethodBO avec ses parents.
     * 
     * @param pAbsoluteMethodName le nom absolu de la mthode
     * @param pFileName le nom absolu du fichier  partir du projet
     * @return la mthode correspondant aux paramtres
     */
    public MethodBO getMethod(String pAbsoluteMethodName, String pFileName);

    /**
     * Dcompose la classe pour construire l'objet ClassBO avec ses parents.
     * 
     * @param pAbsoluteClassName le nom entirement qualifi d'une classe
     * @return la classe sous forme de ClassBO
     */
    public ClassBO getClass(String pAbsoluteClassName);

    /**
     * Retourne la chane pAbsoluteName avant le dernier sparateur
     * ou null si il n'y a pas de sparateur.
     * 
     * @param pAbsoluteName le nom absolu du fils
     * @return le nom absolu du parent
     */
    public String getParentName(String pAbsoluteName);
}
