package com.airfrance.squale.builder.eclipse32.messages;

import java.text.MessageFormat;
import java.util.MissingResourceException;
import java.util.ResourceBundle;

/**
 * Classe de manipulation des messages
 */
public abstract class BuilderMessages {

	/**
	 * Instance de ResourceBudle utilise.
	 */
	private static ResourceBundle mResourceBundle = ResourceBundle
			.getBundle("com.airfrance.squale.builder.eclipse32.messages.builder_messages");

	/**
	 * Retourne la chane de caractre identifie par la cl.
	 * 
	 * @param pKey nom de la cl.
	 * @return la chane associe.
	 */
	public static String getString(String pKey) {
		String value;
		try {
			value = mResourceBundle.getString(pKey);
		} catch (MissingResourceException e) {
			value = "???" + pKey + "???";
		}
		return value;
	}

	/**
	 * 
	 * Retourne la chane de caractre identifie par la cl.
	 * 
	 * @param pKey nom de la cl.
	 * @param pValues les valeurs  insrer dans la chaine
	 * @return la chane associe.
	 */
	public static String getString(String pKey, Object pValues) {
		MessageFormat format = new MessageFormat(getString(pKey));
		return format.format(pValues);
	}
}
